module ExpressAdmin
  module Components
    module Controls
      class CollectionFilter < ExpressTemplates::Components::Configurable
        include ExpressTemplates::Components::Capabilities::Resourceful

          tag :span

          before_build {
            add_class 'filter-criteria'
          }

          contains -> {
            if _filter_column
              text_node "Filter: "
              span(class: 'label filter-tag') { 
                icon_link(:'android-cancel', text: helpers.params[:filter][_filter_column],
                                             href: log_entries_path(filter: {}),
                                             right: true)
              }
            end
          }

          private
            def _filter_column
              helpers.params[:filter].try(:keys).try(:first)
            end
      end
    end
  end
end