module ExpressAdmin
  module Components
    class MediaForm < ExpressTemplates::Components::Configurable

      has_option :max_file_size, 'The maximum file size a user can upload', type: :int, default: 3

      contains -> {
        express_form(config[:id], enctype: 'multipart/form-data', class: 'dropzone'){
          text :title
          text :description
          label_tag('tags', "Tags")
          select_tag("media_item[tags]", helpers.options_for_select(ExpressSite::Tag.all.map(&:name), media_item.tags.map(&:name)), class: 'select2', multiple: true)
          file_upload config[:id], action: form_action, max_file_size: max_file_size
          submit class: 'button', value: 'Upload'
        }
      }

      def form_action
        config[:action] || (resource.try(:persisted?) ? resource_path(resource) : collection_path)
      end

      def max_file_size
        config[:max_file_size]
      end
    end
  end
end
